indexing
	description: "Simple 'Hello, World!' class"

class
	HELLO
	
create
	make

feature {NONE} -- Initialization

	make is
			-- Creation procedure.
		do
			set_name ("anonymous Eiffel Programmer")
		end

feature -- Access

	name: STRING
			-- Name used for greeting.
			
	greeting: STRING is
			-- Printable representation of `HELLO' objects.
		do
			Result := "Hello, " + name + "!"
		end

feature -- Element change

	set_name (a_name: STRING) is
			-- Set `name' with `a_name'.
		require
			name_exists: a_name /= Void
			name_valid: not a_name.is_empty
		do
			name := a_name
		ensure
			name_set: name = a_name
		end

invariant
	name_exists: name /= Void
	name_valid: not name.is_empty

end -- class HELLO
